Attribute VB_Name = "Module1"
Option Explicit
Type SHITEMID
    cb As Long
    abID As Byte
End Type

Type ITEMIDLIST
    mkid As SHITEMID
End Type

Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long

Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long

Public Const NOERROR = 0

'  SHGetSpecialFolderLocation "nFolder" parametri:
'  HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders

'  Windows desktop
Public Const CSIDL_DESKTOP = &H0

'  File system directory con i gruppi di programmi dell'utente
Public Const CSIDL_PROGRAMS = &H2

'  Pannello di Controllo
Public Const CSIDL_CONTROLS = &H3

'  Cartella stampanti
Public Const CSIDL_PRINTERS = &H4

'  Cartella documenti
Public Const CSIDL_PERSONAL = &H5

'  Preferiti (URL)
Public Const CSIDL_FAVORITES = &H6

'  Esecuzione automatica
Public Const CSIDL_STARTUP = &H7

'  Dati recenti
Public Const CSIDL_RECENT = &H8

'  Invia a...
Public Const CSIDL_SENDTO = &H9

'  Cestino
Public Const CSIDL_BITBUCKET = &HA

'  Menu avvio
Public Const CSIDL_STARTMENU = &HB

'  Desktop (fisico)
Public Const CSIDL_DESKTOPDIRECTORY = &H10

'  Risorse del Computer
Public Const CSIDL_DRIVES = &H11

' Rete
Public Const CSIDL_NETWORK = &H12

'  Risorse di rete
Public Const CSIDL_NETHOOD = &H13

'  Fonts
Public Const CSIDL_FONTS = &H14

'  ShellNew
Public Const CSIDL_TEMPLATES = &H15

Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long 'ITEMIDLIST

Public Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

'  BROWSEINFO.ulFlags values:
'  Tipo di cartella
'  Ritorna la directory.
Public Const BIF_RETURNONLYFSDIRS = &H1

'  Non include la cartella Rete
Public Const BIF_DONTGOBELOWDOMAIN = &H2

'  Include una status area nella dialog box.
Public Const BIF_STATUSTEXT = &H4

Public Const BIF_RETURNFSANCESTORS = &H8

'  Ritorna solo  i computers.
Public Const BIF_BROWSEFORCOMPUTER = &H1000

'  Ritorna solo (network) stampanti.
Public Const BIF_BROWSEFORPRINTER = &H2000

